pappso::PeptideNaturalIsotope Class Reference

`#include <peptidenaturalisotope.h>`

Inheritance diagram for pappso::PeptideNaturalIsotope:

## Public Member Functions

| PeptideNaturalIsotope (const PeptideInterfaceSp &peptide, const std::map< Isotope, int > &map_isotope)
| PeptideNaturalIsotope (const PeptideNaturalIsotope &other)
| ~PeptideNaturalIsotope ()
virtual unsigned int | size () const override
virtual const QString | getSequence () const override
| amino acid sequence without modification More...
pappso_double | getMass () const override
virtual int | getNumberOfAtom (AtomIsotopeSurvey atom) const override
| get the number of atom C, O, N, H in the molecule More...
virtual int | getNumberOfIsotope (Isotope isotope) const override
| get the number of isotopes C13, H2, O17, O18, N15, S33, S34, S36 in the molecule More...
pappso_double | getIntensityRatio (unsigned int charge) const
const std::map< Isotope, int > & | getIsotopeMap () const
virtual unsigned int | getIsotopeNumber () const
virtual bool | isPalindrome () const override
| tells if the peptide sequence is a palindrome More...
Public Member Functions inherited from pappso::PeptideInterface
virtual const QString | getSequenceLi () const
| amino acid sequence without modification where L are replaced by I More...
virtual const QString | getName () const
virtual const QString | getFormula (unsigned int charge) const final
virtual bool | matchPeak (PrecisionPtr precision, pappso_double peak_mz, unsigned int charge) const final
Public Member Functions inherited from pappso::Ion
| Ion ()
| ~Ion ()
virtual pappso_double | getMz (unsigned int charge) const final

## Private Attributes

const PeptideInterfaceSp | m_peptide
const std::map< Isotope, int > | m_mapIsotope
pappso_double | m_ratio
pappso_double | m_mass

## Detailed Description

Definition at line 45 of file peptidenaturalisotope.h.

## Constructor & Destructor Documentation

## PeptideNaturalIsotope() [1/2]

pappso::PeptideNaturalIsotope::PeptideNaturalIsotope | ( | const PeptideInterfaceSp & | peptide,
|  | const std::map< Isotope, int > & | map_isotope
| ) |  |

Definition at line 201 of file peptidenaturalisotope.cpp.

: m_peptide(peptide), m_mapIsotope(map_isotope)
{
//_abundance = ((_number_of_carbon - number_of_C13) * ABUNDANCEC12) +
//(number_of_C13 * ABUNDANCEC13); p = pow(0.01, i)*pow(0.99, (c-i))*comb(c,i)
// qDebug()<< "pow" << pow(ABUNDANCEC13, number_of_C13)*pow(1-ABUNDANCEC13,
// (_number_of_carbon-number_of_C13));
// qDebug() <<"conb" << Combinations(_number_of_carbon,number_of_C13);
// CHNO
//_probC13 = pow(ABUNDANCEC13, number_of_C13)*pow((double)1-ABUNDANCEC13,
//(_number_of_carbon-number_of_C13))* (double)
// Combinations(_number_of_carbon,number_of_C13);
// qDebug() <<"_probC13" <<_probC13;
// number of fixed Oxygen atoms (already labelled, not natural) :
int number_of_fixed_oxygen =
m_peptide.get()->getNumberOfIsotope(Isotope::O18) +
m_peptide.get()->getNumberOfIsotope(Isotope::O17);
int number_of_fixed_sulfur =
m_peptide.get()->getNumberOfIsotope(Isotope::S33) +
m_peptide.get()->getNumberOfIsotope(Isotope::S34) +
m_peptide.get()->getNumberOfIsotope(Isotope::S36);
m_ratio = isotopem_ratio_cache(
Isotope::C13,
m_peptide.get()->getNumberOfAtom(AtomIsotopeSurvey::C) -
m_peptide.get()->getNumberOfIsotope(Isotope::C13),
m_mapIsotope.at(Isotope::C13));
m_ratio *= isotopem_ratio_cache(
Isotope::N15,
m_peptide.get()->getNumberOfAtom(AtomIsotopeSurvey::N) -
m_peptide.get()->getNumberOfIsotope(Isotope::N15),
m_mapIsotope.at(Isotope::N15));
m_ratio *= isotopem_ratio_cache(
Isotope::O18,
m_peptide.get()->getNumberOfAtom(AtomIsotopeSurvey::O) -
number_of_fixed_oxygen,
m_mapIsotope.at(Isotope::O18));
m_ratio *= isotopem_ratio_cache(
Isotope::O17,
m_peptide.get()->getNumberOfAtom(AtomIsotopeSurvey::O) -
number_of_fixed_oxygen,
m_mapIsotope.at(Isotope::O17));
m_ratio *= isotopem_ratio_cache(
Isotope::S33,
m_peptide.get()->getNumberOfAtom(AtomIsotopeSurvey::S) -
number_of_fixed_sulfur,
m_mapIsotope.at(Isotope::S33));
m_ratio *= isotopem_ratio_cache(
Isotope::S34,
m_peptide.get()->getNumberOfAtom(AtomIsotopeSurvey::S) -
number_of_fixed_sulfur,
m_mapIsotope.at(Isotope::S34));
m_ratio *= isotopem_ratio_cache(
Isotope::S36,
m_peptide.get()->getNumberOfAtom(AtomIsotopeSurvey::S) -
number_of_fixed_sulfur,
m_mapIsotope.at(Isotope::S36));
// qDebug() << "Aa::getMass() begin";
m_mass = m_peptide.get()->getMass();
m_mass += (DIFFC12C13 * m_mapIsotope.at(Isotope::C13));
m_mass += (DIFFS32S33 * m_mapIsotope.at(Isotope::S33));
m_mass += (DIFFS32S34 * m_mapIsotope.at(Isotope::S34));
m_mass += (DIFFS32S36 * m_mapIsotope.at(Isotope::S36));
m_mass += (DIFFH1H2 * m_mapIsotope.at(Isotope::H2));
m_mass += (DIFFO16O18 * m_mapIsotope.at(Isotope::O18));
m_mass += (DIFFN14N15 * m_mapIsotope.at(Isotope::N15));
m_mass += (DIFFO16O17 * m_mapIsotope.at(Isotope::O17));
// qDebug() << "Aa::getMass() end " << mass;
}
pappso::PeptideNaturalIsotope::m_mass
pappso_double m_mass
Definition: peptidenaturalisotope.h:73
pappso::PeptideNaturalIsotope::m_peptide
const PeptideInterfaceSp m_peptide
Definition: peptidenaturalisotope.h:69
pappso::PeptideNaturalIsotope::m_ratio
pappso_double m_ratio
Definition: peptidenaturalisotope.h:72
pappso::PeptideNaturalIsotope::m_mapIsotope
const std::map< Isotope, int > m_mapIsotope
Definition: peptidenaturalisotope.h:71
pappso::DIFFS32S33
const pappso_double DIFFS32S33(32.9714589101 - MASSSULFUR)
pappso::DIFFS32S34
const pappso_double DIFFS32S34(33.9678670300 - MASSSULFUR)
pappso::DIFFO16O17
const pappso_double DIFFO16O17(16.99913150 - MASSOXYGEN)
pappso::DIFFS32S36
const pappso_double DIFFS32S36(35.9670812000 - MASSSULFUR)
pappso::AtomIsotopeSurvey::C
@ C
pappso::AtomIsotopeSurvey::S
@ S
pappso::AtomIsotopeSurvey::N
@ N
pappso::AtomIsotopeSurvey::O
@ O
pappso::Isotope::S36
@ S36
pappso::Isotope::C13
@ C13
pappso::Isotope::N15
@ N15
pappso::Isotope::S33
@ S33
pappso::Isotope::O18
@ O18
pappso::Isotope::O17
@ O17
pappso::Isotope::S34
@ S34
pappso::Isotope::H2
@ H2
pappso::isotopem_ratio_cache
pappso_double isotopem_ratio_cache(Isotope isotope, unsigned int total, unsigned int heavy)
Definition: peptidenaturalisotope.cpp:95
pappso::DIFFO16O18
const pappso_double DIFFO16O18(17.9991610 - MASSOXYGEN)
pappso::DIFFN14N15
const pappso_double DIFFN14N15(15.0001088982 - MASSNITROGEN)
pappso::DIFFC12C13
const pappso_double DIFFC12C13(1.0033548378)
pappso::DIFFH1H2
const pappso_double DIFFH1H2(2.0141017778 - MPROTIUM)

References pappso::C, pappso::C13, pappso::DIFFC12C13(), pappso::DIFFH1H2(), pappso::DIFFN14N15(), pappso::DIFFO16O17(), pappso::DIFFO16O18(), pappso::DIFFS32S33(), pappso::DIFFS32S34(), pappso::DIFFS32S36(), pappso::H2, pappso::isotopem_ratio_cache(), m_mapIsotope, m_mass, m_peptide, m_ratio, pappso::N, pappso::N15, pappso::O, pappso::O17, pappso::O18, pappso::S, pappso::S33, pappso::S34, and pappso::S36.

## PeptideNaturalIsotope() [2/2]

pappso::PeptideNaturalIsotope::PeptideNaturalIsotope | ( | const PeptideNaturalIsotope & | other | ) |

Definition at line 278 of file peptidenaturalisotope.cpp.

: m_peptide(other.m_peptide), m_mapIsotope(other.m_mapIsotope)
{
m_ratio = other.m_ratio;
}

References m_ratio.

## ~PeptideNaturalIsotope()

pappso::PeptideNaturalIsotope::~PeptideNaturalIsotope | ( |  | ) |

Definition at line 284 of file peptidenaturalisotope.cpp.

{
}

## Member Function Documentation

## getIntensityRatio()

pappso_double pappso::PeptideNaturalIsotope::getIntensityRatio | ( | unsigned int | charge | ) | const

Definition at line 298 of file peptidenaturalisotope.cpp.

{
return m_ratio *
isotopem_ratio_cache(
Isotope::H2,
(m_peptide.get()->getNumberOfAtom(AtomIsotopeSurvey::H) + charge) -
m_peptide.get()->getNumberOfIsotope(Isotope::H2),
m_mapIsotope.at(Isotope::H2));
}
pappso::AtomIsotopeSurvey::H
@ H

References pappso::H, pappso::H2, pappso::isotopem_ratio_cache(), m_mapIsotope, m_peptide, and m_ratio.

## getIsotopeMap()

const std::map< Isotope, int > & pappso::PeptideNaturalIsotope::getIsotopeMap | ( |  | ) | const

Definition at line 324 of file peptidenaturalisotope.cpp.

{
return m_mapIsotope;
}

References m_mapIsotope.

## getIsotopeNumber()

unsigned int pappso::PeptideNaturalIsotope::getIsotopeNumber | ( |  | ) | const

virtual

Definition at line 350 of file peptidenaturalisotope.cpp.

{
// only count variable (natural) isotope
return m_mapIsotope.at(Isotope::C13) + m_mapIsotope.at(Isotope::H2) +
m_mapIsotope.at(Isotope::O17) + m_mapIsotope.at(Isotope::O18) * 2 +
m_mapIsotope.at(Isotope::N15) + m_mapIsotope.at(Isotope::S33) +
(m_mapIsotope.at(Isotope::S34) * 2) +
(m_mapIsotope.at(Isotope::S36) * 4);
}

References pappso::C13, pappso::H2, m_mapIsotope, pappso::N15, pappso::O17, pappso::O18, pappso::S33, pappso::S34, and pappso::S36.

## getMass()

pappso_double pappso::PeptideNaturalIsotope::getMass | ( |  | ) | const

override virtual

Implements pappso::Ion.

Definition at line 290 of file peptidenaturalisotope.cpp.

{
return m_mass;
}

References m_mass.

## getNumberOfAtom()

int pappso::PeptideNaturalIsotope::getNumberOfAtom | ( | AtomIsotopeSurvey | atom | ) | const

override virtual

get the number of atom C, O, N, H in the molecule

Implements pappso::AtomNumberInterface.

Definition at line 311 of file peptidenaturalisotope.cpp.

{
return m_peptide.get()->getNumberOfAtom(atom);
}

References m_peptide.

## getNumberOfIsotope()

int pappso::PeptideNaturalIsotope::getNumberOfIsotope | ( | Isotope | isotope | ) | const

override virtual

get the number of isotopes C13, H2, O17, O18, N15, S33, S34, S36 in the molecule

Implements pappso::AtomNumberInterface.

Definition at line 317 of file peptidenaturalisotope.cpp.

{
return m_mapIsotope.at(isotope) +
m_peptide.get()->getNumberOfIsotope(isotope);
}

References m_mapIsotope, and m_peptide.

## getSequence()

const QString pappso::PeptideNaturalIsotope::getSequence | ( |  | ) | const

override virtual

amino acid sequence without modification

Implements pappso::PeptideInterface.

Definition at line 344 of file peptidenaturalisotope.cpp.

{
return m_peptide.get()->getSequence();
}

References m_peptide.

## isPalindrome()

bool pappso::PeptideNaturalIsotope::isPalindrome | ( |  | ) | const

override virtual

tells if the peptide sequence is a palindrome

Implements pappso::PeptideInterface.

Definition at line 331 of file peptidenaturalisotope.cpp.

{
return m_peptide.get()->isPalindrome();
}

References m_peptide.

## size()

unsigned int pappso::PeptideNaturalIsotope::size | ( |  | ) | const

override virtual

Implements pappso::PeptideInterface.

Definition at line 338 of file peptidenaturalisotope.cpp.

{
return m_peptide.get()->size();
}

References m_peptide.

## Member Data Documentation

## m_mapIsotope

const std::map<Isotope, int> pappso::PeptideNaturalIsotope::m_mapIsotope

private

Definition at line 71 of file peptidenaturalisotope.h.

Referenced by PeptideNaturalIsotope(), getIntensityRatio(), getIsotopeMap(), getIsotopeNumber(), and getNumberOfIsotope().

## m_mass

pappso_double pappso::PeptideNaturalIsotope::m_mass

private

Definition at line 73 of file peptidenaturalisotope.h.

Referenced by PeptideNaturalIsotope(), and getMass().

## m_peptide

const PeptideInterfaceSp pappso::PeptideNaturalIsotope::m_peptide

private

Definition at line 69 of file peptidenaturalisotope.h.

Referenced by PeptideNaturalIsotope(), getIntensityRatio(), getNumberOfAtom(), getNumberOfIsotope(), getSequence(), isPalindrome(), and size().

## m_ratio

pappso_double pappso::PeptideNaturalIsotope::m_ratio

private

Definition at line 72 of file peptidenaturalisotope.h.

Referenced by PeptideNaturalIsotope(), and getIntensityRatio().

The documentation for this class was generated from the following files:

- pappsomspp/peptide/peptidenaturalisotope.h
- pappsomspp/peptide/peptidenaturalisotope.cpp